function S=nsfit(X,Y);
%Input X - wektor wspolrzednych x-owych punktow
%      Y - wektor wspolrzednych y-owych punktow
%Output S - wiersze macierzy S sa wspolczynnikami w porzadku
%          malejacym dla naturalnych funkcji sklejanych na 
%          poszczegolnych przedzialach

N=length(X)-1;
H=diff(X);
D=diff(Y)./H;
A=H(2:N-1); % wspolczynniki A, B, C dla trojprzekatniowej macierzy
B=2*(H(1:N-1)+H(2:N));
C=H(2:N);
U=6*diff(D); % prawa strona ukladu rownan

for k=2:N-1
    temp=A(k-1)/B(k-1);
    B(k)=B(k)-temp*C(k-1);
    U(k)=U(k)-temp*U(k-1);
end

M(N)=U(N-1)/B(N-1);

for k=N-2:-1:1
    M(k+1)=(U(k)-C(k)*M(k+2))/B(k);
end

% naturalne funkcje sklejane M-macierz S''(x_k)
M(1)=0;
M(N+1)=0;

for k=0:N-1
    S(k+1,1)=(M(k+2)-M(k+1))/(6*H(k+1));
    S(k+1,2)=M(k+1)/2;
    S(k+1,3)=D(k+1)-H(k+1)*(2*M(k+1)+M(k+2))/6;
    S(k+1,4)=Y(k+1);
end

% ewentualny wydruk probny dla punktow:
%X=[0 1 2 3]; Y=[0 0.5 2.0 1.5];
%S=nsfit(X,Y)
%x1=X(1):.01:X(2); y1=polyval(S(1,:),x1-X(1));
%x2=X(2):.01:X(3); y2=polyval(S(2,:),x2-X(2));
%x3=X(3):.01:X(4); y3=polyval(S(3,:),x3-X(3));
%plot(x1,y1,x2,y2,x3,y3,X,Y,'.')